#include "include/system.h"

/* 
 * Forces the CPU to wait for an I/O operation to complete.
 * Only use this when there's nothing like a status register
 * or an IRQ to tell you the info has been received.
 */
inline void io_wait()
{
    // port 0x80 is used for 'checkpoints' during POST.
    // The Linux kernel seems to think it is free for use :-/
    asm volatile( "outb %%al, $0x80"
                  : : "a"(0) );
}